LLVM-LINK(1)

NAME
llvm-link - LLVM bitcode linker

SYNOPSIS

llvm-link [options] filename ...

DESCRIPTION

llvm-link takes several LLVM bitcode files and links them together into a single LLVM bitcode file. It writes the output file to standard output, unless the -o option is used to specify a filename.

OPTIONS

-f  Enable binary output on terminals. Normally, llvm-link will refuse to write raw bitcode output if the output stream is a terminal. With this option, llvm-link will write raw bitcode regardless of the output device.

-o filename
    Specify the output file name. If filename is "-", then llvm-link will write its output to standard output.

-S  Write output in LLVM intermediate language (instead of bitcode).

-d  If specified, llvm-link prints a human-readable version of the output bitcode file to standard error.

--help
    Print a summary of command line options.

-v  Verbose mode. Print information about what llvm-link is doing. This typically includes a message for each bitcode file linked in and for each library found.

--override <filename>
    Adds the passed-in file to the link and overrides symbols that have already been declared with the definitions in the file that is passed in. This flag can be specified multiple times to have multiple files act as overrides. If a symbol is declared more than twice, the definition from the file declared last takes precedence.

--import <function:filename>
    Specify a function that should be imported from the specified file for linking with ThinLTO. This option can be specified multiple times to import multiple functions.

--summary-index <filename>
    Specify the path to a file containing the module summary index with the results of an earlier ThinLTO link. This option is required when --import is used.

--internalize
    Internalize the linked symbols.

--disable-debug-info-type-map
    Disables the use of a uniquing type map for debug info.

--only-needed
    Link only needed symbols.

--disable-lazy-loading
    Disable lazy module loading.

--suppress-warnings
    Suppress all linker warnings.

--preserve-bc-uselistorder
    Preserve the use-list order when writing LLVM bitcode.

--preserve-ll-uselistorder
    Preserve the use-list order when writing LLVM assembly.

--ignore-non-bitcode
    Do not error out when a non-bitcode file is encountered while processing an archive.

EXIT STATUS

If llvm-link succeeds, it will exit with 0. Otherwise, if an error occurs, it will exit with a non-zero value.

Author
Maintained by the LLVM Team (https://llvm.org/).

Copyright
2003-2026, LLVM Project